Subject: Re: [PATCH net-next-2.6] netns: call ops_free right after ops_exit

From: [email-masked] (Eric W. Biederman)
Date: Sun, 25 Apr 2010 07:50:34 -0700

David Miller <[email-masked]> writes:

> From: Jiri Pirko <[email-masked]>
> Date: Sun, 25 Apr 2010 11:26:01 +0200
>
>> There's no need to iterate this twice. We can free net generic
>> variables right after exit is called.
>>
>> Signed-off-by: Jiri Pirko <[email-masked]>
>
> Are you sure there are no problems with doing this?
>
> What if there are inter-net variable reference dependencies
> or something like that?
>
> I really suspect it is being done this way on purpose, but
> in the end I defer to experts like Eric B. :-)

I am pretty certain there is a problem.  My memory is fuzzy this
morning but I believe we can have rcu references between various
pieces of the networking stack for a single network namespace.  So we
need to cause all of the network namespace to exit before it is safe
to free those pieces.

Eric